/* status_window.c -- routines for display status information
 *
 * Copyright (c) 1998-2004  Mike Oliphant <grip@nostatic.org>
 *
 *   http://www.nostatic.org/grip
 *
 * This program is free software; you can redistribute it and/or 
 * modify it under the terms of the GNU General Public License as 
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 */
/* This module was inspired by GRIP
 *	http://nostatic.org/grip/
 */

#ifdef HAVE_CONFIG_H
	#include <config.h>
#endif

#ifdef ENABLE_NLS
	#include <libintl.h>
	#define _(String) gettext (String)
#endif


#include <gtk/gtk.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>
#include <vte/vte.h>

#include "win_vte.h"




typedef struct {
	GtkWidget	*AdrWidget;
} VAR_STATUS_WINDOW;

VAR_STATUS_WINDOW	StatusWindow;


// 
// WRITE a line of output to a status window
// 
void WinVte_window_write( gchar *msg )
{
	gchar	*buf;
	gsize	len;
	gint	pos = 0;

	len = strlen( msg );
	buf = (gchar *)g_malloc0(( len * 2 ) +1 );
	while( *msg ) {
		if( 1 ) {
			if( *msg == '\n' ) {
				buf[pos++] = '\r';
				buf[pos++] = '\n';
			} 
			else {
				buf[pos++]=*msg;
			}
		}
		msg++;
	}
	buf[pos] = '\0';
	vte_terminal_feed( VTE_TERMINAL(StatusWindow.AdrWidget), buf, strlen( buf ));
	g_free( buf );
	buf = NULL;
}
// PLACER DU TEXTE DANS LE TEXTVIEW
// 
void WinVte_window_write_va( gchar *p_text, ... )
{
	va_list	VaList;
	gchar	*Ptr = NULL;
	
	WinVte_window_write( p_text );
	va_start( VaList, p_text );
	while( NULL != ( Ptr = va_arg( VaList, gchar * ))) {
		 WinVte_window_write( Ptr );
	}
	va_end( VaList );
}
// 
// VTE RESET
// 
void WinVte_reset( void )
{
	if( NULL != StatusWindow.AdrWidget ) {
		// vte_terminal_reset( VteTerminal *terminal, gboolean full, gboolean clear_history);
		vte_terminal_reset( VTE_TERMINAL(StatusWindow.AdrWidget), TRUE, TRUE );
		WinVte_window_write( "Init VTE for project generate is ok.\n" );
	}
}
// 
// REALIZE VTE
// 
void on_scrolledwindow_vte_realize( GtkWidget *widget, gpointer user_data )
{
	StatusWindow.AdrWidget = vte_terminal_new();
	vte_terminal_set_encoding( VTE_TERMINAL( StatusWindow.AdrWidget ),"UTF-8" );
	gtk_container_add (GTK_CONTAINER (widget), StatusWindow.AdrWidget );
	gtk_widget_show_all( widget );
	WinVte_window_write( "Init VTE for project generate is ok.\n" );
}





